#pragma once

template<typename GV, typename RF, typename Params>
class PhiInitial_Quartersquare :
  public Dune::PDELab::AnalyticGridFunctionBase<
    Dune::PDELab::AnalyticGridFunctionTraits<GV,RF,1>, PhiInitial_Quartersquare<GV,RF,Params> >
{
  const Params& param;
  RF eps;
  RF r;

public:
  typedef Dune::PDELab::AnalyticGridFunctionTraits<GV,RF,1> Traits;

  PhiInitial_Quartersquare(const GV & gv, const Params & params) :
     Dune::PDELab::AnalyticGridFunctionBase<Traits,PhiInitial_Quartersquare<GV,RF,Params> > (gv),
     param(params)
     {
       eps = params.eps;
       r = params.initial.ptree.get("Radius",0.2);
       std::cout << "EPS" << eps;
     }

  inline void evaluateGlobal(const  typename Traits::DomainType & x, typename Traits::RangeType & y) const
  {
    RF rf1 = param.dw.eval_shape((x[0]-r)*1/eps);
    RF rf2 = param.dw.eval_shape((x[1]-r)*1/eps);
    //RF rf1 = 0.5*(1+tanh(1/eps/sqrt(2)*(x[0]-r)));
    //RF rf2 = 0.5*(1+tanh(1/eps/sqrt(2)*(x[1]-r)));

    y=rf1*rf2;
  }
};
